<template>
  <div>
    <span class="q-mt-xl page-header"> {{ t('registerHeader') }} </span>
    <p class="page-subtitle">{{ t('registerSubtitle') }}</p>

    <q-form class="column q-mt-xl" @submit="
        {
    }
      ">
      <q-input v-model="adminPassword" class="q-mb-md" :label="t('adminDashboardPasswordLabel')" type="password"
        required>
        <template #prepend>
          <q-icon name="settings" />
        </template>
      </q-input>
      <q-input v-model="emailInput" class="q-mb-md" :label="t('emailInputLabel')"
        :rules="[(val) => val.length > 0 || t('emailInputEmptyRule')]">
        <template #prepend>
          <q-icon name="mail_outline" />
        </template>
      </q-input>
      <q-input v-model="usernameInput" class="q-mb-md" :label="t('usernameInputLabel')"
        :rules="[(val) => val.length > 0 || t('usernameInputEmptyRule')]">
        <template #prepend>
          <q-icon name="person_outline" />
        </template>
      </q-input>

      <q-input v-model="passwordInput" :label="t('passwordInputLabel')" :type="isVisible ? 'text' : 'password'"
        :rules="[(val) => val.length > 0 || t('passwordInputEmptyRule')]">
        <template #prepend>
          <q-icon name="lock_outline" />
        </template>

        <template #append>
          <q-icon :name="isVisible ? 'visibility_off' : 'visibility'" class="cursor-pointer"
            @click="isVisible = !isVisible" />
        </template>
      </q-input>

      <q-btn rounded class="q-mt-md" padding="md" type="submit" :loading="isLoading" :disable="isLoading"
        @click="handleRegister">
        {{ t('signUpLabel') }}
      </q-btn>
    </q-form>

    <q-space></q-space>

    <div class="q-my-lg flex-center row">
      <span> {{ t('alreadyAccountLabel') }} </span>
      <q-btn rounded flat dense no-caps to="/login">
        {{ t('signInLabel') }}!
      </q-btn>
    </div>
  </div>
</template>

<script setup lang="ts">
import { ref } from 'vue';
import { useI18n } from 'vue-i18n';
import { useAuth } from '../hooks/auth';
import { useRouter } from 'vue-router';

const { t } = useI18n();
const { isLoading, error, register } = useAuth();
const adminPassword = ref('');

const router = useRouter();
const emailInput = ref<string>('');
const passwordInput = ref<string>('');
const usernameInput = ref<string>('');
const isVisible = ref<boolean>(false);

const handleRegister = async () => {
  if (!emailInput.value || !passwordInput.value) {
    return;
  }
  await register({
    admin_dashboard_password: adminPassword.value,
    email: emailInput.value,
    password: passwordInput.value,
    username: usernameInput.value,
  });

  if (!error.value) {
    router.push('/');
  }
};
</script>
